/*
bhnumpad.cpp 
Copyright (C) 2004  Al Kingsley

   GPL version 2 or later.

	Part of:
	BhPos, Copyright (C) 2001-2004   Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
#include "config.h"
#include "bhkeyboard.h"

namespace bhpos{

namespace widget{

BhKeyboard::BhKeyboard(Glib::ustring basedir, NPCALLBACK cb)
{
   kf_callback=cb;
   Glib::ustring ifile;
   
   set_border_width(0);
   set_row_spacings(0);
   set_col_spacings(0);
   this->set_size_request(160, 205);
   
   ifile=basedir + "/keyboard_a.png";
   a=manage(new Gtk::Image(ifile));
   b_a = manage(new Gtk::Button()); 
   b_a->add(*a);
   b_a->set_border_width(0);
   b_a->set_relief(Gtk::RELIEF_NONE);
   b_a->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_b.png";
   a=manage(new Gtk::Image(ifile));
   b_b = manage(new class Gtk::Button()); 
   b_b->add(*b);
   b_b->set_border_width(0);
   b_b->set_relief(Gtk::RELIEF_NONE);
   b_b->set_size_request(40, 41);

   ifile=basedir + "/keyboard_c.png";
   c=manage(new Gtk::Image(ifile));   
   b_c = manage(new Gtk::Button()); 
   b_c->add(*c);
   b_c->set_border_width(0);
   b_c->set_relief(Gtk::RELIEF_NONE);
   b_c->set_size_request(40, 41);

   ifile=basedir + "/keyboard_d.png";
   d=manage(new Gtk::Image(ifile));   
   b_d = manage(new Gtk::Button()); 
   b_d->add(*d);
   b_d->set_border_width(0);
   b_d->set_relief(Gtk::RELIEF_NONE);
   b_d->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_e.png";
   e=manage(new Gtk::Image(ifile));   
   b_e = manage(new Gtk::Button()); 
   b_e->add(*e);
   b_e->set_border_width(0);
   b_e->set_relief(Gtk::RELIEF_NONE);
   b_e->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_f.png";
   f=manage(new Gtk::Image(ifile));   
   b_f = manage(new Gtk::Button()); 
   b_f->add(*f);
   b_f->set_border_width(0);
   b_f->set_relief(Gtk::RELIEF_NONE);
   b_f->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_g.png";
   g=manage(new Gtk::Image(ifile));   
   b_g = manage(new Gtk::Button()); 
   b_g->add(*g);
   b_g->set_border_width(0);
   b_g->set_relief(Gtk::RELIEF_NONE);
   b_g->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_h.png";
   h=manage(new Gtk::Image(ifile));   
   b_h = manage(new Gtk::Button()); 
   b_h->add(*h);
   b_h->set_border_width(0);
   b_h->set_relief(Gtk::RELIEF_NONE);
   b_h->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_i.png";
   i=manage(new Gtk::Image(ifile));   
   b_i = manage(new Gtk::Button()); 
   b_i->add(*i);
   b_i->set_border_width(0);
   b_i->set_relief(Gtk::RELIEF_NONE);
   b_i->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_j.png";
   j=manage(new Gtk::Image(ifile));   
   b_j = manage(new Gtk::Button()); 
   b_j->add(*j);
   b_j->set_border_width(0);
   b_j->set_relief(Gtk::RELIEF_NONE);
   b_j->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_k.png";
   k=manage(new Gtk::Image(ifile));   
   b_k = manage(new Gtk::Button()); 
   b_k->add(*k);
   b_k->set_border_width(0);
   b_k->set_relief(Gtk::RELIEF_NONE);
   b_k->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_l.png";
   l=manage(new Gtk::Image(ifile));   
   b_l = manage(new Gtk::Button()); 
   b_l->add(*l);
   b_l->set_border_width(0);
   b_l->set_relief(Gtk::RELIEF_NONE);
   b_l->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_m.png";
   m=manage(new Gtk::Image(ifile));   
   b_m = manage(new Gtk::Button()); 
   b_m->add(*m);
   b_m->set_border_width(0);
   b_m->set_relief(Gtk::RELIEF_NONE);
   b_m->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_n.png";
   n=manage(new Gtk::Image(ifile));   
   b_n = manage(new Gtk::Button()); 
   b_n->add(*n);
   b_n->set_border_width(0);
   b_n->set_relief(Gtk::RELIEF_NONE);
   b_n->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_o.png";
   o=manage(new Gtk::Image(ifile));   
   b_o = manage(new Gtk::Button()); 
   b_o->add(*o);
   b_o->set_border_width(0);
   b_o->set_relief(Gtk::RELIEF_NONE);
   b_o->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_p.png";
   p=manage(new Gtk::Image(ifile));   
   b_p = manage(new Gtk::Button()); 
   b_p->add(*p);
   b_p->set_border_width(0);
   b_p->set_relief(Gtk::RELIEF_NONE);
   b_p->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_q.png";
   q=manage(new Gtk::Image(ifile));   
   b_q = manage(new Gtk::Button()); 
   b_q->add(*q);
   b_q->set_border_width(0);
   b_q->set_relief(Gtk::RELIEF_NONE);
   b_q->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_r.png";
   r=manage(new Gtk::Image(ifile));   
   b_r = manage(new Gtk::Button()); 
   b_r->add(*r);
   b_r->set_border_width(0);
   b_r->set_relief(Gtk::RELIEF_NONE);
   b_r->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_s.png";
   s=manage(new Gtk::Image(ifile));   
   b_s = manage(new Gtk::Button()); 
   b_s->add(*s);
   b_s->set_border_width(0);
   b_s->set_relief(Gtk::RELIEF_NONE);
   b_s->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_t.png";
   t=manage(new Gtk::Image(ifile));   
   b_t = manage(new Gtk::Button()); 
   b_t->add(*t);
   b_t->set_border_width(0);
   b_t->set_relief(Gtk::RELIEF_NONE);
   b_t->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_u.png";
   u=manage(new Gtk::Image(ifile));   
   b_u = manage(new Gtk::Button()); 
   b_u->add(*u);
   b_u->set_border_width(0);
   b_u->set_relief(Gtk::RELIEF_NONE);
   b_u->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_v.png";
   v=manage(new Gtk::Image(ifile));   
   b_v = manage(new Gtk::Button()); 
   b_v->add(*v);
   b_v->set_border_width(0);
   b_v->set_relief(Gtk::RELIEF_NONE);
   b_v->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_w.png";
   w=manage(new Gtk::Image(ifile));   
   b_w = manage(new Gtk::Button()); 
   b_w->add(*w);
   b_w->set_border_width(0);
   b_w->set_relief(Gtk::RELIEF_NONE);
   b_w->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_x.png";
   x=manage(new Gtk::Image(ifile));   
   b_x = manage(new Gtk::Button()); 
   b_x->add(*x);
   b_x->set_border_width(0);
   b_x->set_relief(Gtk::RELIEF_NONE);
   b_x->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_y.png";
   y=manage(new Gtk::Image(ifile));   
   b_y = manage(new Gtk::Button()); 
   b_y->add(*y);
   b_y->set_border_width(0);
   b_y->set_relief(Gtk::RELIEF_NONE);
   b_y->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_z.png";
   z=manage(new Gtk::Image(ifile));   
   b_z = manage(new Gtk::Button()); 
   b_z->add(*z);
   b_z->set_border_width(0);
   b_z->set_relief(Gtk::RELIEF_NONE);
   b_z->set_size_request(40, 41);
   
   ifile=basedir + "/keyboard_space.png";
   space=manage(new Gtk::Image(ifile));   
   b_space = manage(new Gtk::Button()); 
   b_space->add(*d);
   b_space->set_border_width(0);
   b_space->set_relief(Gtk::RELIEF_NONE);
   b_space->set_size_request(40, 41);
   
   /*
   // qwerty - in fixed
   fixed1->put(*q, 0, 0);
   fixed1->put(*space, 92, 120);
   fixed1->put(*w, 40, 0);
   fixed1->put(*e, 80, 0);
   fixed1->put(*r, 120, 0);
   fixed1->put(*t, 160, 0);
   fixed1->put(*y, 200, 0);
   fixed1->put(*u, 240, 0);
   fixed1->put(*i, 280, 0);
   fixed1->put(*o, 320, 0);
   fixed1->put(*p, 360, 0);
   fixed1->put(*a, 20, 40);
   fixed1->put(*s, 60, 40);
   fixed1->put(*d, 100, 40);
   fixed1->put(*f, 140, 40);
   fixed1->put(*g, 180, 40);
   fixed1->put(*h, 220, 40);
   fixed1->put(*j, 260, 40);
   fixed1->put(*k, 300, 40);
   fixed1->put(*l, 340, 40);
   fixed1->put(*z, 36, 80);
   fixed1->put(*x, 76, 80);
   fixed1->put(*c, 116, 80);
   fixed1->put(*v, 156, 80);
   fixed1->put(*b, 196, 80);
   fixed1->put(*n, 236, 80);
   fixed1->put(*m, 276, 80);
   
   // general a-z block - in table
   */
   show_all();
   
   b_a->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_a_clicked));
   b_b->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_b_clicked));
   b_c->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_c_clicked));
   b_d->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_d_clicked));
   b_e->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_e_clicked));
   b_f->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_f_clicked));
   b_g->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_g_clicked));
   b_h->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_h_clicked));
   b_i->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_i_clicked));
   b_j->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_j_clicked));
   b_k->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_k_clicked));
   b_l->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_l_clicked));
   b_m->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_m_clicked));
   b_n->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_n_clicked));
   b_o->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_o_clicked));
   b_p->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_p_clicked));
   b_q->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_q_clicked));
   b_r->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_r_clicked));
   b_s->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_s_clicked));
   b_t->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_t_clicked));
   b_u->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_u_clicked));
   b_v->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_v_clicked));
   b_w->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_w_clicked));
   b_x->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_x_clicked));
   b_y->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_y_clicked));
   b_z->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_z_clicked));
   b_space->signal_clicked().connect(sigc::mem_fun(*this, &BhKeyboard::on_space_clicked));
}

BhKeyboard::~BhKeyboard()
{  
}

void BhKeyboard::on_a_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_A;
   kf_callback(&keyev);
}

void BhKeyboard::on_b_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_B;
   kf_callback(&keyev);
}

void BhKeyboard::on_c_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_C;
   kf_callback(&keyev);
}

void BhKeyboard::on_d_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_D;
   kf_callback(&keyev);
}

void BhKeyboard::on_e_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_E;
   kf_callback(&keyev);
}

void BhKeyboard::on_f_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_F;
   kf_callback(&keyev);
}

void BhKeyboard::on_g_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_G;
   kf_callback(&keyev);
}

void BhKeyboard::on_h_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_H;
   kf_callback(&keyev);
}

void BhKeyboard::on_i_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_I;
   kf_callback(&keyev);
}

void BhKeyboard::on_j_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_J;
   kf_callback(&keyev);
}

void BhKeyboard::on_k_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_K;
   kf_callback(&keyev);
}

void BhKeyboard::on_l_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_L;
   kf_callback(&keyev);
}

void BhKeyboard::on_m_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_M;
   kf_callback(&keyev);
}

void BhKeyboard::on_n_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_N;
   kf_callback(&keyev);
}

void BhKeyboard::on_o_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_O;
   kf_callback(&keyev);
}

void BhKeyboard::on_p_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_P;
   kf_callback(&keyev);
}

void BhKeyboard::on_q_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_Q;
   kf_callback(&keyev);
}

void BhKeyboard::on_r_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_R;
   kf_callback(&keyev);
}

void BhKeyboard::on_s_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_S;
   kf_callback(&keyev);
}

void BhKeyboard::on_t_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_T;
   kf_callback(&keyev);
}

void BhKeyboard::on_u_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_U;
   kf_callback(&keyev);
}

void BhKeyboard::on_v_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_V;
   kf_callback(&keyev);
}

void BhKeyboard::on_w_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_W;
   kf_callback(&keyev);
}

void BhKeyboard::on_x_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_X;
   kf_callback(&keyev);
}

void BhKeyboard::on_y_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_Y;
   kf_callback(&keyev);
}

void BhKeyboard::on_z_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_Z;
   kf_callback(&keyev);
}

void BhKeyboard::on_space_clicked()
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_space;
   kf_callback(&keyev);
}

}

}
